Foreman - Bug #31432

Error with BMC plugin: undefined method "power_status' for
#<HostsController:0x00007f7b55ee2550> Did you mean? power_host_path

12/02/2020 01:29 PM - Harm Endres

Status: Duplicate

Priority: Normal

Assignee: Lukas Zapletal

Category: BMC

Target version: 222

Difficulty: Fixed in Releases:
Triaged: Yes Found in Releases: 2.21
Bugzilla link: Red Hat JIRA:
Pull request:

Description

Hey folks,

| have an issue with the BMC plugin.
In the BMC tab of the Host the following error occurs.

Oops, we're sorry but something went wrong undefined method “power_status' for #<HostsController:0x00007f7b55ee2550> Did you
mean? power_host_path

2020-12-02T13:01:21 [I|app|85190458] Backtrace for 'undefined method "“power_status' for #<HostsCon
troller:0x00007£7b55ee2550>

Did you mean? power_host_path' error (NoMethodError): undefined method 'power_status' for #<Hosts
Controller:0x00007£7b55ee2550>

Did you mean? power_host_path

/usr/share/foreman/app/controllers/hosts_controller.rb:268:in “bmc'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/action_controller/metal/basic_imp
licit_render.rb:6:in "“send_action'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/abstract_controller/base.rb:195:1
n ‘process_action'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/action_controller/metal/rendering
.rb:30:1in “process_action'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/abstract_controller/callbacks.rb:
42:in "block in process_action'
/usr/share/foreman/vendor/ruby/2.5.0/gems/activesupport-6.0.3.4/1lib/active_support/callbacks.rb:11
2:in “block in run_callbacks'
/usr/share/foreman/app/controllers/concerns/foreman/controller/timezone.rb:10:in "~ set_timezone'
/usr/share/foreman/vendor/ruby/2.5.0/gems/activesupport-6.0.3.4/1ib/active_support/callbacks.rb:12
1:in “block in run_callbacks'
/usr/share/foreman/app/models/concerns/foreman/thread_session.rb:32:in “clear_thread'
/usr/share/foreman/vendor/ruby/2.5.0/gems/activesupport-6.0.3.4/1lib/active_support/callbacks.rb:12
1:in "block in run_callbacks'
/usr/share/foreman/app/controllers/concerns/foreman/controller/topbar_sweeper.rb:12:in " set_topbar
_sweeper_controller'
/usr/share/foreman/vendor/ruby/2.5.0/gems/activesupport-6.0.3.4/1ib/active_support/callbacks.rb:12
1:in “block in run_callbacks'
/usr/share/foreman/vendor/ruby/2.5.0/gems/audited-4.9.0/1lib/audited/sweeper.rb:14:in "“around'
/usr/share/foreman/vendor/ruby/2.5.0/gems/activesupport-6.0.3.4/1lib/active_support/callbacks.rb:12
1:in “block in run_callbacks'
/usr/share/foreman/vendor/ruby/2.5.0/gems/audited-4.9.0/1ib/audited/sweeper.rb:14:in " around’
/usr/share/foreman/vendor/ruby/2.5.0/gems/activesupport-6.0.3.4/1lib/active_support/callbacks.rb:12
l1:in “block in run_callbacks'
/usr/share/foreman/vendor/ruby/2.5.0/gems/activesupport-6.0.3.4/1ib/active_support/callbacks.rb:13
9:in “run_callbacks'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/abstract_controller/callbacks.rb:
41:in “process_action’
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/action_controller/metal/rescue.rb
:22:in “process_action'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1lib/action_controller/metal/instrumen
tation.rb:33:in ‘block in process_action'
/usr/share/foreman/vendor/ruby/2.5.0/gems/activesupport-6.0.3.4/1lib/active_support/notifications.r
b:180:in "block in instrument'
/usr/share/foreman/vendor/ruby/2.5.0/gems/activesupport-6.0.3.4/1ib/active_support/notifications/i
nstrumenter.rb:24:in " instrument'
/usr/share/foreman/vendor/ruby/2.5.0/gems/activesupport-6.0.3.4/1ib/active_support/notifications.r
b:180:in "instrument'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1lib/action_controller/metal/instrumen
tation.rb:32:in “process_action'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/action_controller/metal/params_wr
apper.rb:245:1in “process_action'
/usr/share/foreman/vendor/ruby/2.5.0/gems/activerecord-6.0.3.4/1ib/active_record/railties/controll
er_runtime.rb:27:in “process_action'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/abstract_controller/base.rb:136:1
n ‘process'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionview-6.0.3.4/1lib/action_view/rendering.rb:39:in "p
rocess'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/action_controller/metal.rb:190:in
“dispatch'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/action_controller/metal.rb:254:in
“dispatch'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/action_dispatch/routing/route_set
.rb:50:1in “dispatch’
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1lib/action_dispatch/routing/route_set
.rb:33:in "serve'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1lib/action_dispatch/journey/router.rb
:49:in “block in serve'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1lib/action_dispatch/journey/router.rb
:32:in “each'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/action_dispatch/journey/router.rb
:32:1in "~ serve'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1lib/action_dispatch/routing/route_set
.rb:834:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/apipie-dsl-2.3.0/1lib/apipie_dsl/static_dispatcher.rb:67:
in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/apipie-rails-0.5.18/1ib/apipie/static_dispatcher.rb:66:1i
n ‘call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/apipie-rails-0.5.18/1ib/apipie/extractor/recorder.rb:137
:in “call!
/usr/share/foreman/lib/foreman/middleware/telemetry.rb:10:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/apipie-rails-0.5.18/1ib/apipie/middleware/checksum_in_he
aders.rb:27:in ‘call'
/usr/share/foreman/lib/foreman/middleware/catch_json_parse_errors.rb:9:in “call’
/usr/share/foreman/vendor/ruby/2.5.0/gems/rack-2.2.3/1ib/rack/tempfile_reaper.rb:15:in “call'
.0/gems/rack-2.2.3/1lib/rack/etag.rb:27:in “call'
.0/gems/rack-2.2.3/1lib/rack/conditional_get.rb:27:in ‘call'
.0/gems/rack-2.2.3/1lib/rack/head.rb:12:in “call'
.0/gems/actionpack-6.0.3.4/1lib/action_dispatch/http/content_secu

/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
rity_policy.rb:18:in “call'
/usr/share/foreman/lib/foreman/middleware/logging_context_session.rb:22:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/rack-2.2.3/1ib/rack/session/abstract/id.rb:266:in 'conte
xt'

/usr/share/foreman/vendor/ruby/2.5.0/gems/rack-2.2.3/1ib/rack/session/abstract/id.rb:260:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/action_dispatch/middleware/cookie
s.rb:648:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1lib/action_dispatch/middleware/callba
cks.rb:27:in "block in call’
/usr/share/foreman/vendor/ruby/2.5.0/gems/activesupport-6.0.3.4/1lib/active_support/callbacks.rb:10
1:in “run_callbacks'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1lib/action_dispatch/middleware/callba
cks.rb:26:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/action_dispatch/middleware/action
able_exceptions.rb:18:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/action_dispatch/middleware/debug_
exceptions.rb:32:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/action_dispatch/middleware/show_e
xceptions.rb:33:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/railties-6.0.3.4/1lib/rails/rack/logger.rb:37:in ‘call_ap
pV

/usr/share/foreman/vendor/ruby/2.5.0/gems/railties-6.0.3.4/1ib/rails/rack/logger.rb:28:in ‘call’
/usr/share/foreman/vendor/ruby/2.5.0/gems/sprockets-rails-3.2.2/1ib/sprockets/rails/quiet_assets.r
b:13:in “call'

/usr/share/foreman/lib/foreman/middleware/logging_context_request.rb:11:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1ib/action_dispatch/middleware/remote
_ip.rb:81l:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1lib/action_dispatch/middleware/reques
t_id.rb:27:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/rack-2.2.3/1ib/rack/method_override.rb:24:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/rack-2.2.3/1ib/rack/runtime.rb:22:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/activesupport-6.0.3.4/1ib/active_support/cache/strategy/
local_cache_middleware.rb:29:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1lib/action_dispatch/middleware/execut
or.rb:14:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1lib/action_dispatch/middleware/static
.rb:126:1in “call'

/usr/share/foreman/vendor/ruby/2.5.0/gems/rack-2.2.3/1lib/rack/sendfile.rb:110:in “call’
/usr/share/foreman/vendor/ruby/2.5.0/gems/actionpack-6.0.3.4/1lib/action_dispatch/middleware/host_a
uthorization.rb:76:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/secure_headers-6.3.1/1ib/secure_headers/middleware.rb:11
:in “call!

/usr/share/foreman/vendor/ruby/2.5.0/gems/railties-6.0.3.4/1lib/rails/engine.rb:527:in “call'
/usr/share/foreman/vendor/ruby/2.5.0/gems/railties-6.0.3.4/1lib/rails/railtie.rb:190:in “public_sen
dV

/usr/share/foreman/vendor/ruby/2.5.0/gems/railties-6.0.3.4/1ib/rails/railtie.rb:190:in ‘method_mis
sing'

.3/1lib/rack/urlmap.rb:74:in “block in call'
.3/1lib/rack/urlmap.rb:58:in “each'
.3/1lib/rack/urlmap.rb:58:in “call’
.6/lib/puma/configuration.rb:228:in “call’
.6/1lib/puma/server.rb:713:in “handle_request'
.6/1lib/puma/server.rb:472:in “process_client'

/usr/share/foreman/vendor/ruby/2.5.0/gems/rack-2.
.0/gems/rack-2.
.0/gems/rack-2.
.0/gems/puma-4.
.0/gems/puma-4.
.0/gems/puma-4.
.0/gems/puma-4.
.0/gems/puma-4.

/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.

/usr/share/foreman/vendor/ruby/2. .6/1lib/puma/server.rb:328:in ‘block in run'

(GG, NG, BNC, NG BN C NG, BN C |
/usr/share/foreman/vendor/ruby/2. .6/1lib/puma/thread_pool.rb:134:in ‘block in spaw
n_thread’
/usr/share/foreman/vendor/ruby/2.5.0/gems/logging-2.3.0/1ib/logging/diagnostic_context.rb:474:in
block in create_with_logging_context'

2020-12-02T13:01:21 [I|app|85190458] Rendering common/500.html.erb

2020-12-02T13:01:21 [I|app|185190458] Rendered common/500.html.erb (Duration: 5.0ms | Allocations

5924)

Platform: Ubuntu 18.04
Foreman installer plugin config:

bmc: true

bmc_listen_on: https

bmc_default_provider: freeipmi

bmc_ssh_user: root

bmc_ssh_key: "/usr/share/foreman/.ssh/id_rsa"
bmc_ssh_powerstatus: 'true'
bmc_ssh_powercycle: shutdown -r +1
bmc_ssh_poweroff: shutdown +1
bmc_ssh_poweron: 'false'

| was not able to get the debug log:
foreman-rake errors:fetch_log request_id=85190458 --trace
** Invoke errors:fetch_log (first_time)

** Invoke environment (first_time)
** Execute environment
API controllers newer than Apipie cache!

** Execute errors:fetch_log
rake aborted!

NoMethodError: private method “puts'
/usr/share/foreman/lib/tasks/errors.rake:30:in
0/gems/rake-13.0.
.0/gems/rake-13.0.
0/gems/rake-13.0.
.0/gems/rake-13.0.

/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.

h_call _chain'

5.

5
5o
5

Run apipie:cache rake task

called for nil:NilClass
“block

(2 levels) in
1/1ib/rake/task.
1/1ib/rake/task.
1/1ib/rake/task.
1/lib/rake/task.

rb:
rb:
rb:
rb:

/usr/lib/ruby/2.5.0/monitor.rb:226:in “mon_synchronize'

/usr/share/foreman/vendor/ruby/2.

ain'

/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.

els) in top_level'

/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.

_level'

/usr/share/foreman/vendor/ruby/2.

eads'

/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.

eption_handling'

/usr/share/foreman/vendor/ruby/2.

/usr/bin/rake:27:in ' <main>'

Tasks: TOP => errors:fetch_log

Thank you in advance
Harm

5

[6)]

.0/gems/rake-13.
.0/gems/rake—-13.
.0/gems/rake-13.
.0/gems/rake-13.

.0/gems/rake-13.
.0/gems/rake-13.

.0/gems/rake—-13.
.0/gems/rake—-13.
.0/gems/rake-13.

.0/gems/rake-13.

.0/gems/rake-13.

0

.1/1lib/rake/task.rb:

.1/1lib/rake/task.rb:

.1/1ib/rake/application.

.1/1ib/rake/application.
.1/1ib/rake/application.

.1/1ib/rake/application.
.1/1ib/rake/application.
.1/1ib/rake/application.

.1/1ib/rake/application.

.1/1ib/rake/application.

281:
219:
199:

188:
.1/1ib/rake/application.

in
in
in
in

in

in

rb:
rb:

rb

rb:
rb:
rb:
rb:

rb:

rb:

‘block
‘each'

to regenerate cache.

<top (required)>'
281:1
281:

in execute'

‘execute'

"block

in invoke_wit

‘invoke_with_call_ch

‘invoke'

160:in "~ invoke_task'
116:in “block (2 lev
:116:1in “each'’

116:in "block in top
125:in “run_with_thr
110:in “top_level'
83:in “block in run'
186:in "~ standard_exc
80:in “run'

Related issues:

Related to Foreman - Bug #30713: Helpers power_status not available

Closed

History

#1 - 12/02/2020 02:45 PM - Lukas Zapletal

- Related to Bug #30713: Helpers power_status not available added

#2 - 12/02/2020 02:46 PM - Lukas Zapletal

- Assignee set to Lukas Zapletal

Hello! This bug was fixed in 2.3 via #30713, apply the linked patch it is just one line. | will schedule this into 2.2.x series.

#3 - 12/02/2020 02:46 PM - Lukas Zapletal
- Target version set to 2.2.2

- Triaged changed from No to Yes

#4 - 12/02/2020 02:51 PM - Lukas Zapletal

- Status changed from New to Duplicate

I will close this issue and we can track the rest in the original issue.
https://projects.theforeman.org/issues/30713
